
import com.ewon.ewonitf.IOServer;
import com.ewon.ewonitf.IOTag;
import com.ewon.ewonitf.IOValue;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author eWonSupport_Adm



/**
 *
 * @author eWonSupport_Adm
 */

  public class CommThreadClass extends IOServer implements Runnable {
    
      private Vector TagsList = new Vector();
      
      //USER Params
      private String szIP = null;
      private String szPort = null;
      private String szUsername = null;
      private String szPassword = null;
      private int int_Debug = 0;
      private int int_PollRate = 5000;
      
      //POLLINGCYCLCOUNTER            
      private long int_Framecounter = 0;
      private IOTag ioTag_PollingCycleCounter= null;
      private String PollingCycleCounterAddress = "POLLINGCYCLECOUNTER";
      
      SocketConnection sc  = null;
      InputStream is  = null;
      OutputStream os  = null;
      
      
      
   public void onRegister() throws Exception
   {
      //if (DEBUG)
        //
       //setJavaReplyTimeout(1000000);   //Let Java freeze the eWON while debugging.
   }
      
    public CommThreadClass()
   {
      super();      
      setServerName("Telnet");
      /* setTagHelper must NOT be called, the tag helper defaults to "" */
      //setTagHelper("{\"topic\":{ \"A\":{}}}");       
   }
       
    public void onPassConfig(boolean applyConfig, boolean checkConfig) throws Exception 
    {
        szIP = getConfigParam("ip","192.168.120.77");  
        szPort = getConfigParam("port","8023");  
        szUsername = getConfigParam("username","guest");        
        szPassword = getConfigParam("password","guest");        
        int_Debug = Integer.parseInt(getConfigParam("debug","0"));
        int_PollRate = Integer.parseInt(getConfigParam("pollrate","5000"));
    }
 
    public IOValue onGetIo(IOTag ioTag)
    {
      return ioTag.getIoData();
    }
           
    public IOTag onGetIoInfo(String topicName, String ioName) throws Exception {
      
        IOTag ioTag;
        
        
        //Validate the Address
        Vector Available_Addresses = new Vector();
        
        Available_Addresses.addElement("TEMPERATURE");
        Available_Addresses.addElement("PRESSURE");
        Available_Addresses.addElement("VOLTAGE");        
        Available_Addresses.addElement("CURRENT");
        Available_Addresses.addElement("POWER");
        Available_Addresses.addElement("SERVO-COUNTERS");
        Available_Addresses.addElement(PollingCycleCounterAddress);
        
        if(!Available_Addresses.contains(Split(ioName," ",0)))  //Split for SERVO-COUNTERS # address type
            throw new Exception("TELNET : Invalid Address");    
        
        if (PollingCycleCounterAddress.equals(ioName))            
           ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_UINT32, true);  
        else
           ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);  
        
       
      return ioTag;
   }


     public void onAdviseIo(IOTag ioTag) throws Exception 
     {         
        if (PollingCycleCounterAddress.equals(ioTag.getIoName()))
            ioTag_PollingCycleCounter = ioTag;
        else
            TagsList.addElement(ioTag);
            
     }

     public void onUnadviseIo(IOTag ioTag) throws Exception 
     {
         
         if (PollingCycleCounterAddress.equals(ioTag.getIoName()))
            ioTag_PollingCycleCounter = null;
        else
            TagsList.removeElement(ioTag);
         
        
     }
   
     public void onPutIo(IOTag ioTag, IOValue ioData) throws Exception
     {
        //In case of writing
         if (PollingCycleCounterAddress.equals(ioTag.getIoName()))
             int_Framecounter= ioData.getUInt32();
     }         
      
     public void run()
     {              
      while(true)
       {       
            try 
            {
                if(TagsList.isEmpty())
                {
                    if (int_Debug == 1) System.out.println("TELNET DEBUG: No tag to process" );
                    continue;
                }
                
                if (szIP == null)
                {
                    if (int_Debug == 1) System.out.println("TELNET DEBUG: Waiting for IOServer parameters");
                    continue;
                }
                
                if (int_Debug == 1) System.out.println("TELNET DEBUG - socket://" + szIP + ":" + szPort);
                sc = (SocketConnection) Connector.open("socket://" + szIP + ":" + szPort);

                is = sc.openInputStream();
                os = sc.openOutputStream();

                if (ReadDataOnTelnetSocket().indexOf("Username:") > -1)
                    WriteDataOnTelnetSocket(szUsername);
                                           
                if (ReadDataOnTelnetSocket().indexOf("Password:") > -1)
                     WriteDataOnTelnetSocket(szPassword);

                if (!(ReadDataOnTelnetSocket().indexOf("ServoDriver>") > -1))
                {
                    System.out.println("TELNET ERROR: Command prompt not received.");
                    continue;
                }
                
                WriteDataOnTelnetSocket("SESSION");
                String SessionID = ReadDataOnTelnetSocket();
                if (int_Debug == 1) System.out.println("Session #" + SessionID);
                    
                for(int i=0;i<TagsList.size();i++)   
                {
                    IOTag myTag = (IOTag) TagsList.elementAt(i);
                    String szTagAddress = myTag.getIoName();
                    
                    WriteDataOnTelnetSocket(szTagAddress);
                    try
                    {  
                       float NewValue = Float.parseFloat(Split(ReadDataOnTelnetSocket(),"\r\n",1));                       
                       
                       //Update value only if it has changed.
                       if (myTag.getValueFloat32() != NewValue) 
                       {
                            myTag.setValueFloat32(NewValue);
                            postIoChange(myTag);
                            if (int_Debug == 1) System.out.println("TELNET DEBUG: New value for Tag " + szTagAddress + " : " + String.valueOf(NewValue));
                       }
                    }
                    catch(Exception e)
                    {
                        System.out.println("TELNET ERROR: Cannot set value of Tag " + szTagAddress);
                        System.out.println("TELNET ERROR: " + e.getMessage());
                    }
                    
                }
                
                WriteDataOnTelnetSocket("exit");
                
                int_Framecounter ++;
                if( ioTag_PollingCycleCounter != null)
                {                   
                    ioTag_PollingCycleCounter.setValueUInt32(int_Framecounter);
                    postIoChange(ioTag_PollingCycleCounter);
                }
                                
            } 
              catch (Exception ex) 
            {
                 System.out.println("TELNET ERROR: " + ex.getMessage());
               
            }
            finally
            {
                try {
                    Thread.sleep(int_PollRate/2);
                    /* Close Socket */
                    is.close();
                    os.close();
                    sc.close();
                    System.gc();
                    
                    Thread.sleep(int_PollRate/2);
                } catch (Exception ex) {                    
                }
            }
         }  
     }
     
     private void WriteDataOnTelnetSocket(String data) throws IOException
     {
        os.write((data + "\r\n").getBytes());
        if (int_Debug == 1) System.out.println("TELNET DEBUG - Write :" + data);
     }
     
     private String ReadDataOnTelnetSocket() throws IOException
     {
         /*Read Data From Buffer*/
         
         int ch=0;
         StringBuffer str = new StringBuffer();
         long timeSaved = System.currentTimeMillis() + 1000 ;
         long CurTime = System.currentTimeMillis();
         while(timeSaved > CurTime) //Timeout of 1000 millesec
         {
             CurTime = System.currentTimeMillis();
             while (is.available() != 0)
             {
                  timeSaved = CurTime + 500;
                  ch = is.read();
                  str.append((char)ch);
             }          
         }
         
         if (str.length() == 0)
             System.out.println("TELNET ERROR - Read: TIMEOUT");
         else
             if (int_Debug == 1) System.out.println("TELNET DEBUG - Read: " + str.toString());
                
             
        return str.toString();
             
     }
     
    public static String Split(String Src, String SplitChar, int pos)
    {
    
        int startpos = 0;
        int endpos = 0;
        String sz_result = "";
        
        try
        {
            for(int i=0;i<=pos;i++)
            {
                if(endpos==-1)//next item does not exist
                    return "";
                
                endpos = Src.indexOf(SplitChar,startpos);
                if (endpos == -1) //String not ended by SplitChar
                    sz_result = Src.substring(startpos);
                else
                    sz_result = Src.substring(startpos,endpos);

                startpos = endpos + 1;
            }
        }
        catch(Exception e)
        {
            sz_result = "";
        }

        return sz_result;
    }
  }
  
    

